unit SetKepU;    {A kiemelsek (pont,l) belltshoz}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls,
  SetU;

type
  TSetKepForm = class(TForm)
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    ButtonOk: TButton;
    ButtonMegsem: TButton;
    ColorDialog1: TColorDialog;
    ComboBox1: TComboBox;
    procedure SpeedButton1Click(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ButtonMegsemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Telepules: boolean;
    TelepRec: TTelepRec;
    VonalRec: TVonalRec;
    constructor Create(AOwner:TComponent; ATelepules:boolean; AValue:byte);
  end;


implementation

{$R *.DFM}

procedure TSetKepForm.SpeedButton1Click(Sender: TObject);
begin
 {Arra a sznre lljunk a szinvlasztsnl, amelyiket vltoztatjuk}
 if Telepules then
  ColorDialog1.Color:=TelepRec.Szin
 else
  ColorDialog1.Color:=VonalRec.Szin;
 if ColorDialog1.Execute then
  if Telepules then begin
   TelepRec.Szin:=ColorDialog1.Color;
   TelepRajz(Image1,TelepRec);
  end else begin
   VonalRec.Szin:=ColorDialog1.Color;
   VonalRajz(Image1,VonalRec);
  end;
end;

procedure TSetKepForm.ComboBox1Change(Sender: TObject);
begin
 with Sender as TComboBox do
  if Telepules then begin
   TelepRec.Szel:=StrToInt(Items[ItemIndex]);
   TelepRajz(Image1,TelepRec);
  end else begin
   VonalRec.Vast:=StrToInt(Items[ItemIndex]);
   VonalRajz(Image1,VonalRec);
  end;
end;

procedure TSetKepForm.ButtonOkClick(Sender: TObject);
begin
 ModalResult:=mrOk;
end;

procedure TSetKepForm.ButtonMegsemClick(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

constructor TSetKepForm.Create(AOwner:TComponent;
                               ATelepules:boolean; AValue:byte);
var BM:TBitMap;
begin
 inherited Create(AOWner);
 {Paramterek tvtele}
 Telepules:=ATelepules;
 if Telepules then
  ComboBoxBeallit(ComboBox1,TelepSzelMin,TelepSzelMax,AValue)
 else
  ComboBoxBeallit(ComboBox1,VonalVastMin,VonalVastMax,AValue);
 with Image1 do begin
  BM:=TBitMap.Create;
  BM.Width:=Width;
  BM.Height:=Height;
  Picture.Graphic:=BM;
 end;
end;

procedure TSetKepForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action:=caFree;
end;

end.
