unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, unit2;

const
 Fajta=5; Max=90; FajlNev='Lotto.txt'; MezoSzel=3;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Generalas: TButton;
    Mentes: TButton;
    Betoltes: TButton;
    Modositas: TButton;
    procedure FormCreate(Sender: TObject);
    procedure GeneralasClick(Sender: TObject);
    procedure MentesClick(Sender: TObject);
    procedure BetoltesClick(Sender: TObject);
    procedure ModositasClick(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GeneralasClick(Sender: TObject);
var h:set of 1..Max; i,j,x:integer;
begin
 h:=[];
 for i:=1 to Fajta do begin
  repeat
   x:=random(Max)+1;
  until not (x in h);
  h:=h+[x];
 end;
 j:=0;
 for i:=1 to Max do
  if i in h then begin
   j:=j+1;
   StringGrid1.Cells[j,StringGrid1.Row]:=IntToStr(i);
  end;
 with StringGrid1 do
  {A legals sorba generltunk?}
  if Row=RowCount-1 then
   begin
    {A ht sorszma}
    Cells[0,Row]:=IntToStr(Row)+'.';
    {Sorok szmnak nvelse}
    RowCount:=RowCount+1;
    {Az utols sor legyen res}
    Rows[RowCount-1].Clear;
   end;
end;

procedure TForm1.MentesClick(Sender: TObject);
var f:textfile; i,j:integer;
begin
 AssignFile(f,ExtractFilePath(ParamStr(0))+FajlNev);
 Rewrite(f);
 with StringGrid1 do
  for i:=1 to RowCount-2 do begin
   for j:=1 to Fajta do
    write(f,Cells[j,i]:MezoSzel);
   writeln(f);
  end;
 CloseFile(f);
end;

procedure TForm1.BetoltesClick(Sender: TObject);
var f:textfile; j:integer; st:string;
begin
 st:=ExtractFilePath(ParamStr(0))+FajlNev;
 if FileExists(st) then begin
  AssignFile(f,st);
  Reset(f);
  try
   with StringGrid1 do begin
    RowCount:=2;
    while not eof(f) do begin
     readln(f,st);
     Cells[0,RowCount-1]:=IntToStr(RowCount-1);
     for j:=1 to Fajta do
      Cells[j,RowCount-1]:=IntToStr(StrToInt(
       trim(copy(st,(j-1)*MezoSzel+1,MezoSzel))));
      RowCount:=RowCount+1;
    end;
   end;
   CloseFile(f);
  except
   {Hibs fjl}
   CloseFile(f);
   MessageDlg('Hibs fjl!',mtError,[mbOK],0);
   StringGrid1.RowCount:=2;
  end;
  with StringGrid1 do begin
   {Az utols sor legyen res}
   Rows[RowCount-1].Clear;
   {Az els szelvny els szma legyen az aktulis}
   Col:=1; Row:=1;
  end;
 end else
  raise Exception.Create('Hinyzik a fjl ('+st+')!');
end;

procedure TForm1.ModositasClick(Sender: TObject);
var tol,ig:integer; Form2:TForm2;
begin
 with StringGrid1 do
  if Cells[Col,Row]<>'' then begin
   if Col=1 then tol:=1 else tol:=StrToInt(Cells[Col-1,Row])+1;
   if Col=Fajta then ig:=Max else ig:=StrToInt(Cells[Col+1,Row])-1;
   Form2:=TForm2.Create(Self,tol,ig);
   if Form2.ShowModal=mrOk then
    Cells[Col,Row]:=Form2.ComboBox1.Items[Form2.ComboBox1.ItemIndex];
   Form2.Free;
  end;
end;

{Duplakattintssal mdosthat}
procedure TForm1.StringGrid1DblClick(Sender: TObject);
begin
 ModositasClick(Sender);
end;

{Enter-el mdosthat}
procedure TForm1.StringGrid1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key=chr(13) then
  ModositasClick(Sender);
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
 {A vletlenszm genertor inicializlsa}
 randomize;
 {A rcs belltsai}
 with StringGrid1 do begin
  ColCount:=Fajta+1;
  RowCount:=2;
  for i:=1 to Fajta do
   Cells[i,0]:=IntToStr(i)+'.';
  Width:=(DefaultColWidth+2)*ColCount;
  Cells[0,0]:='Ht/Ssz';
 end;
end;

end.
