unit RFokusz;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, SegedU;

{A Fkuszl mrtkek (ennyivel ugrlunk a kezdkpen)}
const Mertekek:array[0..2] of integer=(1,10,30);

type
  TFokuszForm = class(TForm)
    ComboBox1: TComboBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    ButtonOk: TButton;
    ButtonMegsem: TButton;
    procedure ButtonKezelo(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure ButtonMegsemClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    {Mekkora mrtkkel fkuszlunk}
    Mertek:byte;
    {Az eredeti rtkek a Mgsem esetre}
    EKEPXMIN,EKEPXMAX,EKEPYMIN,EKEPYMAX:integer;
  public
  end;

implementation

uses NagyitasU;

{$R *.DFM}

procedure TFokuszForm.ComboBox1Change(Sender: TObject);
begin
 Mertek:=Mertekek[ComboBox1.ItemIndex];
end;

{A nagytkeret fkuszlsa}
procedure TFokuszForm.ButtonKezelo(Sender: TObject);
var s,o,FX,FY:integer; neve:string;
begin
 with Sender as TBitBtn do begin
  neve:=Name;
  Szamot(neve,s,o);
 end;
 with RajzForm do begin
  case s of
   1:if KEPXMIN>=Mertek then begin                 {Bal}
      dec(KEPXMIN,Mertek); dec(KEPXMAX,Mertek);
     end;
   2:if KEPXMAX<=maxx-Mertek then begin            {Jobb}
      inc(KEPXMIN,Mertek); inc(KEPXMAX,Mertek);
     end;
   3:if KEPYMIN>=Mertek then begin                 {Le}
      dec(KEPYMIN,Mertek); dec(KEPYMAX,Mertek);
     end;
   4:if KEPYMAX<=maxy-Mertek then begin            {Fel}
      inc(KEPYMIN,Mertek); inc(KEPYMAX,Mertek);
     end;
  end;
  Keprajzol;
 end;
end;

procedure TFokuszForm.ButtonOkClick(Sender: TObject);
begin
 {Hogy a nagytsokon lpdelve is ez legyen}
 with RajzForm do begin
  kepxmaxt[aktnagy]:=kepxmax;
  kepxmint[aktnagy]:=kepxmin;
  kepymaxt[aktnagy]:=kepymax;
  kepymint[aktnagy]:=kepymin;
 end;
 ModalResult:=mrOk;
end;

procedure TFokuszForm.ButtonMegsemClick(Sender: TObject);
var FX,FY:integer;
begin
 with RajzForm do begin
  KEPXMIN:=EKEPXMIN;
  KEPXMAX:=EKEPXMAX;
  KEPYMIN:=EKEPYMIN;
  KEPYMAX:=EKEPYMAX;
  Keprajzol;
 end;
 ModalResult:=mrCancel;
end;

procedure TFokuszForm.FormCreate(Sender: TObject);
begin
 {Kzepesen kezdjnk}
 ComboBox1.ItemIndex:=1;
 Mertek:=Mertekek[1];
 {Az eredeti rtkek a Mgsem esetre}
 with RajzForm do begin
  EKEPXMIN:=KEPXMIN;
  EKEPXMAX:=KEPXMAX;
  EKEPYMIN:=KEPYMIN;
  EKEPYMAX:=KEPYMAX;
 end;
end;

procedure TFokuszForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action:=caFree;
end;

end.
