unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  Jelek=set of char;
  JoJelekMetodus=function(Szoveg:string):Jelek of object;
  TartalomMetodus=function(Szoveg:string):boolean of object;

  TForm3 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1Click(Sender: TObject);
    procedure Edit1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Edit1Enter(Sender: TObject);
  private
    { Private declarations }
    JoJelek:JoJelekMetodus;
    Tartalom:TartalomMetodus;
    {Az Edit vezrl belltsa}
    procedure Alaphelyzet(Edit:TEdit);
  public
    { Public declarations }
    constructor Create(AOwner:TComponent;
     Fejlec,Prompt,Szoveg:string;
     AJoJelek:JoJelekMetodus; ATartalom:TartalomMetodus);
  end;

implementation

{$R *.DFM}

procedure TForm3.Button1Click(Sender: TObject);
begin
 if Tartalom(Edit1.Text) then
  ModalResult:=mrOk;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
 ModalResult:=mrCancel;
end;

{A kiemels levtele, kurzort a szveg vgre}
procedure TForm3.Alaphelyzet(Edit:TEdit);
begin
 with Edit do begin
  SelStart:=Length(Text);
  SelLength:=0;
 end;
end;

{A vk kdok a Windows unit-ban deklarldnak}
procedure TForm3.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 {A kurzor mozgs s a Shift+Insert beszrs letiltsa}
 if (key in [vk_left,vk_home,vk_up,vk_insert]) then key:=0;
end;

procedure TForm3.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 {A Ctrl+V beilleszts letiltsa}
 if key in [#22] then key:=#0;
 {A nem j karakterek kiszrse}
 if not (key in JoJelek(Edit1.Text)) then key:=#0;
end;

procedure TForm3.Edit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Alaphelyzet(TEdit(Sender));
end;

procedure TForm3.Edit1Click(Sender: TObject);
begin
 Alaphelyzet(TEdit(Sender));
end;

procedure TForm3.Edit1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Alaphelyzet(TEdit(Sender));
end;

procedure TForm3.Edit1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Alaphelyzet(TEdit(Sender));
end;

procedure TForm3.Edit1Enter(Sender: TObject);
begin
 Alaphelyzet(TEdit(Sender));
end;

constructor TForm3.Create(AOwner:TComponent;
 Fejlec,Prompt,Szoveg:string;
 AJoJelek:JoJelekMetodus;
 ATartalom:TartalomMetodus);
var pm:TPopupMenu;
begin
 {Az rklt Create meghvsa}
 inherited Create(AOwner);
 {Sajt adatok inicializlsa}
 Caption:=Fejlec;
 Label1.Caption:=Prompt;
 Edit1.Text:=Szoveg;
 JoJelek:=AJoJelek;
 Tartalom:=ATartalom;
 {A jobb egrgomb 'letiltsa'}
 pm:=TPopupMenu.Create(AOwner);
 pm.AutoPopup:=false;
 Edit1.PopupMenu:=pm;
end;

end.
